<div
  class="flex-row full-height full-width overflow-hidden"
  [sqtmCoreWorkspace]="'test-case-workspace'"
>
  @if (componentData$ | async; as componentData) {
    <div
      class="flex-column full-width full-height neutral-background-color overflow-hidden"
    >
      <sqtm-core-configurable-banner />
      <div class="flex-fixed-size p-10">
        <div class="flex-row full-width">
          <span class="view-label m-l-10 font-16-px">{{
            'sqtm-core.test-case-workspace.modif-during-exec.step.title'
              | translate
          }}</span>
          <div class="m-l-auto m-r-10">
            @if (!componentData.milestonesAllowModification) {
              <span class="font-20-px sqtm-core-error-message m-r-40">
                <i
                  nz-icon
                  nzType="sqtm-core-nav:milestone"
                  nzTheme="outline"
                  class="action-icon-size"
                  nz-tooltip
                  [nzTooltipTitle]="
                    'sqtm-core.entity.generic.milestone.locked' | translate
                  "
                  nzTooltipPlacement="bottom"
                ></i>
              </span>
            }
          </div>
        </div>
        <div class="flex-row full-width">
          <div
            class="m-t-6"
            [attr.data-test-element-id]="'return-to-previous-page-button'"
            (click)="navigateBack()"
          >
            <i
              nz-icon
              nzType="sqtm-core-generic:back"
              nzTheme="outline"
              class="current-workspace-button action-icon-size m-t-auto m-b-auto"
              nz-tooltip
              [nzTooltipTitle]="
                'sqtm-core.test-case-workspace.modif-during-exec.return-to-exec'
                  | translate
              "
            ></i>
          </div>
          <div
            [attr.data-test-element-id]="'test-case-name'"
            class="sqtm-core-screen-title m-l-20"
          >
            {{ getTestCaseName(componentData.actionStep) }}
          </div>
          @if (isCalledStep(componentData.actionStep)) {
            <div
              [attr.data-test-element-id]="'called-test-case-name'"
              class="sqtm-core-screen-title m-l-30"
            >
              {{
                'sqtm-core.test-case-workspace.modif-during-exec.call-of'
                  | translate
              }}
              {{ getCalledTestCaseName(componentData.actionStep) }}
            </div>
          }
        </div>
      </div>
      <div class="flex-row full-height overflow-hidden p-5">
        <div class="full-height full-width flex-column overflow-hidden p-5">
          <div
            class="flex-fixed-size full-width flex-row p-5 current-workspace-main-color section-header"
          >
            <div class="m-l-5">
              {{ 'sqtm-core.test-case-workspace.title.coverages' | translate }}
            </div>
            <div
              class="m-l-auto font-20-px"
              [attr.data-test-element-id]="'coverages-actions'"
            >
              <sqtm-core-toggle-icon
                [active]="
                  componentData.milestonesAllowModification &&
                  componentData.permissions.canLink
                "
                (clickedInActiveMode)="openRequirementTreePicker()"
              >
                <i
                  [attr.data-test-element-id]="'add-coverages'"
                  nz-tooltip="{{
                    'sqtm-core.test-case-workspace.coverages.add'
                      | translate
                      | capitalize
                  }}"
                  nz-icon
                  class="m-r-15 action-icon-size"
                  nzType="sqtm-core-generic:add"
                  nzTheme="outline"
                ></i>
              </sqtm-core-toggle-icon>
              <sqtm-core-toggle-icon
                [active]="
                  componentData.milestonesAllowModification &&
                  componentData.permissions.canLink
                "
                (clickedInActiveMode)="
                  navigateToSearchRequirementForStepCoverage(
                    componentData.actionStep.actionStepTestCaseId,
                    componentData.actionStep.id
                  )
                "
              >
                <i
                  [attr.data-test-icon-id]="'search-coverages'"
                  nz-tooltip="{{
                    'sqtm-core.test-case-workspace.coverages.search'
                      | translate
                      | capitalize
                  }}"
                  nz-icon
                  class="m-r-15 action-icon-size remove-chrome-router-link-border"
                  nzType="sqtm-core-tree:search"
                  nzTheme="outline"
                ></i>
              </sqtm-core-toggle-icon>
              <sqtm-core-toggle-icon
                [active]="activateDeleteCoverageButton$ | async"
              >
                <i
                  [attr.data-test-toolbar-button-id]="'remove-coverages'"
                  nz-tooltip="{{
                    'sqtm-core.test-case-workspace.coverages.delete'
                      | translate
                      | capitalize
                  }}"
                  nz-icon
                  class="m-r-15 action-icon-size"
                  nzType="sqtm-core-generic:unlink"
                  nzTheme="outline"
                  nz-dropdown
                  [nzDropdownMenu]="deleteCoverageMenu"
                  [nzDisabled]="!(activateDeleteCoverageButton$ | async)"
                ></i>
              </sqtm-core-toggle-icon>
              <nz-dropdown-menu #deleteCoverageMenu="nzDropdownMenu">
                <ul
                  [attr.data-test-menu-id]="'remove-coverages'"
                  nz-menu
                  nzSelectable
                >
                  <li
                    nz-menu-item
                    [attr.data-test-menu-item-id]="
                      'delete-requirement-coverage-from-test-case'
                    "
                    (click)="showDeleteCoverageFromTestCase()"
                  >
                    {{
                      'sqtm-core.detailed-test-step-view.dialogs.coverages.remove-many.from-test-case.button'
                        | translate
                    }}
                  </li>
                  <li
                    nz-menu-item
                    [attr.data-test-menu-item-id]="
                      'delete-requirement-coverage-from-test-step'
                    "
                    [nzDisabled]="!(activateDeleteCoverageFromStep$ | async)"
                    (click)="showDeleteCoverageFromTestStep()"
                  >
                    {{
                      'sqtm-core.detailed-test-step-view.dialogs.coverages.remove-many.from-test-step.button'
                        | translate
                    }}
                  </li>
                </ul>
              </nz-dropdown-menu>
            </div>
          </div>
          <div
            [attr.data-test-element-id]="'requirement-drop-zone'"
            #dropRequirementZone
            class="full-width full-height overflow-hidden container-background-color container-border"
            [sqtmCoreDraggableDropZone]="'requirement-table-drop-zone'"
            (dragEnter)="dragEnter($event)"
            (dragLeave)="dragLeave($event)"
            (drop)="drop($event)"
            (dragCancel)="removeBorderOnRequirementTable()"
          >
            <div class="full-width full-height p-10" style="overflow: auto">
              <sqtm-app-detailed-step-coverage-table></sqtm-app-detailed-step-coverage-table>
            </div>
          </div>
        </div>
        <div class="full-height full-width flex-column overflow-hidden p-5">
          <div
            class="flex-fixed-size full-width flex-row p-5 current-workspace-main-color section-header"
          >
            <div class="m-l-5 flex-fixed-size">
              {{ 'sqtm-core.detailed-test-step-view.steps.title' | translate }}
            </div>
            <div class="flex-row full-width navigator">
              <sqtm-core-step-navigator
                [currentStep]="currentStepIndex$ | async"
                [totalStep]="totalStepCount$ | async"
                [minimumStep]="0"
                (navigateTo)="handleNavigateTo($event)"
              >
              </sqtm-core-step-navigator>
            </div>
          </div>
          <div
            #dropFileZone
            [attr.data-test-element-id]="'attachment-drop-zone'"
            class="full-width full-height overflow-hidden container-background-color container-border"
            sqtmCoreAttachmentDropZone
            (filesDropEvent)="dropFiles($event)"
            (filesDragEnterEvent)="dragFilesEnter()"
            (filesDragLeaveEvent)="dragFileLeave()"
          >
            <sqtm-app-exec-test-case-step-information></sqtm-app-exec-test-case-step-information>
          </div>
        </div>
      </div>
    </div>
    <sqtm-core-drawer
      [localTheme]="requirementWorkspace"
      [isVisible]="componentData.actionStep.uiState.openRequirementTreePicker"
      [titleKey]="'sqtm-core.tree-picker.requirement.title'"
      (close)="closeRequirementPicker()"
    >
      @if (componentData.actionStep.uiState.openRequirementTreePicker) {
        <sqtm-core-requirement-picker
          [pickerPersistenceKey]="'bind-requirement-to-test-case'"
        >
        </sqtm-core-requirement-picker>
      }
    </sqtm-core-drawer>
  }
</div>

<ng-template #loading>
  <sqtm-core-full-page-loading-icon></sqtm-core-full-page-loading-icon>
</ng-template>
